JaxbAnnotationIntrospector (Jackson JSON Processor)
Date: 2013-07-14

org.codehaus.jackson.xc

## Class JaxbAnnotationIntrospector

- java.lang.Object
- - org.codehaus.jackson.map.AnnotationIntrospector
  - - org.codehaus.jackson.xc.JaxbAnnotationIntrospector

- All Implemented Interfaces:
    Versioned

      public class JaxbAnnotationIntrospector
      extends AnnotationIntrospector
      implements Versioned

  Annotation introspector that leverages JAXB annotations where applicable to JSON mapping.

  The following JAXB annotations are not supported yet (but some may be supported in future)
  - `XmlAnyAttribute` not yet used (as of 1.5) but may be in future (as an alias for @JsonAnySetter?)
  - `XmlAnyElement` not yet used, may be as per [JACKSON-253]
  - `XmlAttachmentRef`: JSON does not support external attachments
  - `XmlElementDecl`
  - `XmlElementRefs` because Jackson doesn't have any support for 'named' collection items -- however, this may become partially supported as per [JACKSON-253].
  - `XmlID` because Jackson doesn't support referential integrity. NOTE: this too may be supported in future if/when id references are handled
  - `XmlIDREF` same as `XmlID`
  - `XmlInlineBinaryData` since the underlying concepts (like XOP) do not exist in JSON -- Jackson will always use inline base64 encoding as the method
  - `XmlList` because JSON does have (or necessarily need) method of serializing list of values as space-separated Strings
  - `XmlMimeType`
  - `XmlMixed` since JSON has no concept of mixed content
  - `XmlRegistry`
  - `XmlRootElement` is recognized and used (as of 1.7) for defining root wrapper name (if used)
  - `XmlSchema` not used, unlikely to be used
  - `XmlSchemaType` not used, unlikely to be used
  - `XmlSchemaTypes` not used, unlikely to be used
  - `XmlSeeAlso` not needed for anything currently (could theoretically be useful for locating subtypes for Polymorphic Type Handling)
  Note also the following limitations:
  - Any property annotated with `XmlValue` will have a property named 'value' on its JSON object.
  Author:
    Ryan Heaton, Tatu Saloranta

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.codehaus.jackson.map.AnnotationIntrospector

      `AnnotationIntrospector.Pair, AnnotationIntrospector.ReferenceProperty`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected JsonDeserializer<?>` | `_dataHandlerDeserializer`
    `protected JsonSerializer<?>` | `_dataHandlerSerializer`
    `protected String` | `_jaxbPackageName`
    `protected static String` | `MARKER_FOR_DEFAULT`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `JaxbAnnotationIntrospector()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected Class<?>` | `_doFindDeserializationType(Annotated a, JavaType baseType, String propName)`
    `protected TypeResolverBuilder<?>` | `_typeResolverFromXmlElements(AnnotatedMember am)`
    `protected XmlAccessType` | `findAccessType(Annotated ac)` Method for locating JAXB `XmlAccessType` annotation value for given annotated entity, if it has one, or inherits one from its ancestors (in JAXB sense, package etc).
    `protected <A extends Annotation> A` | `findAnnotation(Class<A> annotationClass, Annotated annotated, boolean includePackage, boolean includeClass, boolean includeSuperclasses)` Finds an annotation associated with given annotatable thing; or if not found, a default annotation it may have (from super class, package and so on)
    `VisibilityChecker<?>` | `findAutoDetectVisibility(AnnotatedClass ac, VisibilityChecker<?> checker)` Method for checking if annotations indicate changes to minimum visibility levels needed for auto-detecting property elements (fields, methods, constructors).
    `Boolean` | `findCachability(AnnotatedClass ac)` Method that checks whether specified class has annotations that indicate that it is (or is not) cachable.
    `Class<JsonDeserializer<?>>` | `findContentDeserializer(Annotated am)` Method for getting a deserializer definition for content (values) of associated `Collection`, `array` or `Map` property.
    `String` | `findDeserializablePropertyName(AnnotatedField af)` Method for checking whether given member field represent a deserializable logical property; and if so, returns the name of that property.
    `Class<?>` | `findDeserializationContentType(Annotated a, JavaType baseContentType, String propName)` Method for accessing additional narrowing type definition that a method can have, to define more specific content type to use; content refers to Map values and Collection/array elements.
    `Class<?>` | `findDeserializationKeyType(Annotated am, JavaType baseKeyType, String propName)` Method for accessing additional narrowing type definition that a method can have, to define more specific key type to use.
    `Class<?>` | `findDeserializationType(Annotated a, JavaType baseType, String propName)` JAXB does allow specifying (more) concrete class for deserialization by using \@XmlElement annotation.
    `JsonDeserializer<?>` | `findDeserializer(Annotated am)` Method for getting a deserializer definition on specified method or field.
    `String` | `findEnumValue(Enum<?> e)` !!! 12-Oct-2009, tatu: This is hideously slow implementation, called potentially for every single enum value being serialized.
    `String` | `findGettablePropertyName(AnnotatedMethod am)` Method for checking whether given method has an annotation that suggests property name associated with method that may be a "getter".
    `Boolean` | `findIgnoreUnknownProperties(AnnotatedClass ac)` Method for checking whether an annotation indicates that all unknown properties
    `Class<KeyDeserializer>` | `findKeyDeserializer(Annotated am)` Method for getting a deserializer definition for keys of associated `Map` property.
    `String[]` | `findPropertiesToIgnore(AnnotatedClass ac)` Method for finding list of properties to ignore for given class (null is returned if not specified).
    `TypeResolverBuilder<?>` | `findPropertyContentTypeResolver(MapperConfig<?> config, AnnotatedMember am, JavaType containerType)` Method for checking if given structured property entity (field or method that has nominal value of Map, Collection or array type) has annotations that indicate that specific type resolver is to be used for handling type information of contained values.
    `String` | `findPropertyNameForParam(AnnotatedParameter param)` Method for checking whether given set of annotations indicates property name for associated parameter.
    `TypeResolverBuilder<?>` | `findPropertyTypeResolver(MapperConfig<?> config, AnnotatedMember am, JavaType baseType)` Method for checking if given property entity (field or method) has annotations that indicate that specific type resolver is to be used for handling instances.
    `String` | `findRootName(AnnotatedClass ac)` Method for locating name used as "root name" (for use by some serializers when outputting root-level object -- mostly for XML compatibility purposes) for given class, if one is defined.
    `String` | `findSerializablePropertyName(AnnotatedField af)` Method for checking whether given member field represent a serializable logical property; and if so, returns the name of that property.
    `JsonSerialize.Inclusion` | `findSerializationInclusion(Annotated a, JsonSerialize.Inclusion defValue)` Implementation of this method is slightly tricky, given that JAXB defaults differ from Jackson defaults.
    `String[]` | `findSerializationPropertyOrder(AnnotatedClass ac)` Method for accessing defined property serialization order (which may be partial).
    `Boolean` | `findSerializationSortAlphabetically(AnnotatedClass ac)` Method for checking whether an annotation indicates that serialized properties for which no explicit is defined should be alphabetically (lexicograpically) ordered
    `Class<?>` | `findSerializationType(Annotated a)` Method for accessing annotated type definition that a method/field can have, to be used as the type for serialization instead of the runtime type.
    `JsonSerialize.Typing` | `findSerializationTyping(Annotated a)` Method for accessing declared typing mode annotated (if any).
    `Class<?>[]` | `findSerializationViews(Annotated a)` Method for checking if annotated serializable property (represented by field or getter method) has definitions for views it is to be included in.
    `JsonSerializer<?>` | `findSerializer(Annotated am)` Method for getting a serializer definition on specified method or field.
    `String` | `findSettablePropertyName(AnnotatedMethod am)` Method for checking whether given method has an annotation that suggests property name associated with method that may be a "setter".
    `List<NamedType>` | `findSubtypes(Annotated a)` Method for locating annotation-specified subtypes related to annotated entity (class, method, field).
    `String` | `findTypeName(AnnotatedClass ac)` Method for checking if specified type has explicit name.
    `TypeResolverBuilder<?>` | `findTypeResolver(MapperConfig<?> config, AnnotatedClass ac, JavaType baseType)` Method for checking if given class has annotations that indicate that specific type resolver is to be used for handling instances.
    `boolean` | `hasAnySetterAnnotation(AnnotatedMethod am)` Method for checking whether given method has an annotation that suggests that the method is to serve as "any setter"; method to be used for setting values of any properties for which no dedicated setter method is found.
    `boolean` | `hasAsValueAnnotation(AnnotatedMethod am)` Method for checking whether given method has an annotation that suggests that the return value of annotated method should be used as "the value" of the object instance; usually serialized as a primitive value such as String or number.
    `boolean` | `hasCreatorAnnotation(Annotated am)` Method for checking whether given annotated item (method, constructor) has an annotation that suggests that the method is a "creator" (aka factory) method to be used for construct new instances of deserialized values.
    `boolean` | `hasIgnoreMarker(AnnotatedMember m)` Method called to check whether given property is marked to be ignored; but NOT to determine if it should necessarily be ignored, since that may depend on other factors.
    `boolean` | `isHandled(Annotation ann)` An annotation is handled if it's in the same package as @XmlElement, including subpackages.
    `boolean` | `isIgnorableConstructor(AnnotatedConstructor c)`
    `boolean` | `isIgnorableField(AnnotatedField f)` Method for checking whether there is an annotation that indicates that given field should be ignored for all operations (serialization, deserialization).
    `boolean` | `isIgnorableMethod(AnnotatedMethod m)` Method for checking whether there is an annotation that indicates that given method should be ignored for all operations (serialization, deserialization).
    `Boolean` | `isIgnorableType(AnnotatedClass ac)` Method for checking whether properties that have specified type (class, not generics aware) should be completely ignored for serialization and deserialization purposes.
    `Version` | `version()` Method that will return version information stored in and read from jar that contains this class.

    - ### Methods inherited from class org.codehaus.jackson.map.AnnotationIntrospector

      `allIntrospectors, allIntrospectors, findContentSerializer, findFilterId, findInjectableValueId, findKeySerializer, findReferenceType, findSerializationContentType, findSerializationKeyType, findValueInstantiator, hasAnyGetterAnnotation, nopInstance, pair, shouldUnwrapProperty`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### MARKER_FOR_DEFAULT

          protected static final String MARKER_FOR_DEFAULT

      See Also:
        Constant Field Values

    - #### _jaxbPackageName

          protected final String _jaxbPackageName

    - #### _dataHandlerSerializer

          protected final JsonSerializer<?> _dataHandlerSerializer

    - #### _dataHandlerDeserializer

          protected final JsonDeserializer<?> _dataHandlerDeserializer

  - ### Constructor Detail

    - #### JaxbAnnotationIntrospector

          public JaxbAnnotationIntrospector()

  - ### Method Detail

    - #### version

          public Version version()

      Method that will return version information stored in and read from jar that contains this class.
      Specified by:
        `version` in interface `Versioned`
      Since:
        1.6

    - #### isHandled

          public boolean isHandled(Annotation ann)

      An annotation is handled if it's in the same package as @XmlElement, including subpackages.
      Specified by:
        `isHandled` in class `AnnotationIntrospector`
      Parameters:
        `ann` - The annotation.
      Returns:
        Whether the annotation is in the JAXB package.

    - #### findCachability

          public Boolean findCachability(AnnotatedClass ac)

      Description copied from class: `AnnotationIntrospector`
      Method that checks whether specified class has annotations that indicate that it is (or is not) cachable. Exact semantics depend on type of class annotated and using class (factory or provider).

      Currently only used with deserializers, to determine whether provider should cache instances, and if no annotations are found, assumes non-cachable instances.

      Overrides:
        `findCachability` in class `AnnotationIntrospector`
      Returns:
        True, if class is considered cachable within context, False if not, and null if introspector does not care either way.

    - #### findRootName

          public String findRootName(AnnotatedClass ac)

      Description copied from class: `AnnotationIntrospector`
      Method for locating name used as "root name" (for use by some serializers when outputting root-level object -- mostly for XML compatibility purposes) for given class, if one is defined. Returns null if no declaration found; can return explicit empty String, which is usually ignored as well as null.
      Specified by:
        `findRootName` in class `AnnotationIntrospector`

    - #### findPropertiesToIgnore

          public String[] findPropertiesToIgnore(AnnotatedClass ac)

      Description copied from class: `AnnotationIntrospector`
      Method for finding list of properties to ignore for given class (null is returned if not specified). List of property names is applied after other detection mechanisms, to filter out these specific properties from being serialized and deserialized.
      Specified by:
        `findPropertiesToIgnore` in class `AnnotationIntrospector`

    - #### findIgnoreUnknownProperties

          public Boolean findIgnoreUnknownProperties(AnnotatedClass ac)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether an annotation indicates that all unknown properties
      Specified by:
        `findIgnoreUnknownProperties` in class `AnnotationIntrospector`

    - #### isIgnorableType

          public Boolean isIgnorableType(AnnotatedClass ac)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether properties that have specified type (class, not generics aware) should be completely ignored for serialization and deserialization purposes.
      Overrides:
        `isIgnorableType` in class `AnnotationIntrospector`
      Parameters:
        `ac` - Type to check
      Returns:
        Boolean.TRUE if properties of type should be ignored; Boolean.FALSE if they are not to be ignored, null for default handling (which is 'do not ignore')

    - #### hasIgnoreMarker

          public boolean hasIgnoreMarker(AnnotatedMember m)

      Description copied from class: `AnnotationIntrospector`
      Method called to check whether given property is marked to be ignored; but NOT to determine if it should necessarily be ignored, since that may depend on other factors.

      Default implementation calls existing 'isIgnored' methods such as `AnnotationIntrospector.isIgnorableField(AnnotatedField)` and `AnnotationIntrospector.isIgnorableMethod(AnnotatedMethod)`.

      Overrides:
        `hasIgnoreMarker` in class `AnnotationIntrospector`

    - #### findAutoDetectVisibility

          public VisibilityChecker<?> findAutoDetectVisibility(AnnotatedClass ac,
                                                      VisibilityChecker<?> checker)

      Description copied from class: `AnnotationIntrospector`
      Method for checking if annotations indicate changes to minimum visibility levels needed for auto-detecting property elements (fields, methods, constructors). A baseline checker is given, and introspector is to either return it as is (if no annotations are found), or build and return a derived instance (using checker's build methods).
      Overrides:
        `findAutoDetectVisibility` in class `AnnotationIntrospector`

    - #### findAccessType

          protected XmlAccessType findAccessType(Annotated ac)

      Method for locating JAXB `XmlAccessType` annotation value for given annotated entity, if it has one, or inherits one from its ancestors (in JAXB sense, package etc). Returns null if nothing has been explicitly defined.

    - #### findTypeResolver

          public TypeResolverBuilder<?> findTypeResolver(MapperConfig<?> config,
                                                AnnotatedClass ac,
                                                JavaType baseType)

      Description copied from class: `AnnotationIntrospector`
      Method for checking if given class has annotations that indicate that specific type resolver is to be used for handling instances. This includes not only instantiating resolver builder, but also configuring it based on relevant annotations (not including ones checked with a call to `AnnotationIntrospector.findSubtypes(org.codehaus.jackson.map.introspect.Annotated)`
      Overrides:
        `findTypeResolver` in class `AnnotationIntrospector`
      Parameters:
        `config` - Configuration settings in effect (for serialization or deserialization)
        `ac` - Annotated class to check for annotations
        `baseType` - Base java type of value for which resolver is to be found
      Returns:
        Type resolver builder for given type, if one found; null if none

    - #### findPropertyTypeResolver

          public TypeResolverBuilder<?> findPropertyTypeResolver(MapperConfig<?> config,
                                                        AnnotatedMember am,
                                                        JavaType baseType)

      Description copied from class: `AnnotationIntrospector`
      Method for checking if given property entity (field or method) has annotations that indicate that specific type resolver is to be used for handling instances. This includes not only instantiating resolver builder, but also configuring it based on relevant annotations (not including ones checked with a call to `AnnotationIntrospector.findSubtypes(org.codehaus.jackson.map.introspect.Annotated)`
      Overrides:
        `findPropertyTypeResolver` in class `AnnotationIntrospector`
      Parameters:
        `config` - Configuration settings in effect (for serialization or deserialization)
        `am` - Annotated member (field or method) to check for annotations
        `baseType` - Base java type of property for which resolver is to be found
      Returns:
        Type resolver builder for properties of given entity, if one found; null if none

    - #### findPropertyContentTypeResolver

          public TypeResolverBuilder<?> findPropertyContentTypeResolver(MapperConfig<?> config,
                                                               AnnotatedMember am,
                                                               JavaType containerType)

      Description copied from class: `AnnotationIntrospector`
      Method for checking if given structured property entity (field or method that has nominal value of Map, Collection or array type) has annotations that indicate that specific type resolver is to be used for handling type information of contained values. This includes not only instantiating resolver builder, but also configuring it based on relevant annotations (not including ones checked with a call to `AnnotationIntrospector.findSubtypes(org.codehaus.jackson.map.introspect.Annotated)`
      Overrides:
        `findPropertyContentTypeResolver` in class `AnnotationIntrospector`
      Parameters:
        `config` - Configuration settings in effect (for serialization or deserialization)
        `am` - Annotated member (field or method) to check for annotations
        `containerType` - Type of property for which resolver is to be found (must be a container type)
      Returns:
        Type resolver builder for values contained in properties of given entity, if one found; null if none

    - #### _typeResolverFromXmlElements

          protected TypeResolverBuilder<?> _typeResolverFromXmlElements(AnnotatedMember am)

    - #### findSubtypes

          public List<NamedType> findSubtypes(Annotated a)

      Description copied from class: `AnnotationIntrospector`
      Method for locating annotation-specified subtypes related to annotated entity (class, method, field). Note that this is only guaranteed to be a list of directly declared subtypes, no recursive processing is guarantees (i.e. caller has to do it if/as necessary)
      Overrides:
        `findSubtypes` in class `AnnotationIntrospector`
      Parameters:
        `a` - Annotated entity (class, field/method) to check for annotations

    - #### findTypeName

          public String findTypeName(AnnotatedClass ac)

      Description copied from class: `AnnotationIntrospector`
      Method for checking if specified type has explicit name.
      Overrides:
        `findTypeName` in class `AnnotationIntrospector`
      Parameters:
        `ac` - Class to check for type name annotations

    - #### isIgnorableMethod

          public boolean isIgnorableMethod(AnnotatedMethod m)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether there is an annotation that indicates that given method should be ignored for all operations (serialization, deserialization).

      Note that this method should ONLY return true for such explicit ignoral cases; and not if method just happens not to be visible for annotation processor.

      Specified by:
        `isIgnorableMethod` in class `AnnotationIntrospector`
      Returns:
        True, if an annotation is found to indicate that the method should be ignored; false if not.

    - #### isIgnorableConstructor

          public boolean isIgnorableConstructor(AnnotatedConstructor c)

      Specified by:
        `isIgnorableConstructor` in class `AnnotationIntrospector`

    - #### isIgnorableField

          public boolean isIgnorableField(AnnotatedField f)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether there is an annotation that indicates that given field should be ignored for all operations (serialization, deserialization).
      Specified by:
        `isIgnorableField` in class `AnnotationIntrospector`
      Returns:
        True, if an annotation is found to indicate that the field should be ignored; false if not.

    - #### findSerializer

          public JsonSerializer<?> findSerializer(Annotated am)

      Description copied from class: `AnnotationIntrospector`
      Method for getting a serializer definition on specified method or field. Type of definition is either instance (of type `JsonSerializer`) or Class (of type `Class`); if value of different type is returned, a runtime exception may be thrown by caller.

      Note: this variant was briefly deprecated for 1.7; should not be

      Specified by:
        `findSerializer` in class `AnnotationIntrospector`

    - #### findSerializationType

          public Class<?> findSerializationType(Annotated a)

      Description copied from class: `AnnotationIntrospector`
      Method for accessing annotated type definition that a method/field can have, to be used as the type for serialization instead of the runtime type. Type returned (if any) needs to be widening conversion (super-type). Declared return type of the method is also considered acceptable.
      Specified by:
        `findSerializationType` in class `AnnotationIntrospector`
      Returns:
        Class to use instead of runtime type

    - #### findSerializationInclusion

          public JsonSerialize.Inclusion findSerializationInclusion(Annotated a,
                                                           JsonSerialize.Inclusion defValue)

      Implementation of this method is slightly tricky, given that JAXB defaults differ from Jackson defaults. As of version 1.5 and above, this is resolved by honoring Jackson defaults (which are configurable), and only using JAXB explicit annotations.
      Overrides:
        `findSerializationInclusion` in class `AnnotationIntrospector`
      Returns:
        Enumerated value indicating which properties to include in serialization

    - #### findSerializationTyping

          public JsonSerialize.Typing findSerializationTyping(Annotated a)

      Description copied from class: `AnnotationIntrospector`
      Method for accessing declared typing mode annotated (if any). This is used for type detection, unless more granular settings (such as actual exact type; or serializer to use which means no type information is needed) take precedence.
      Specified by:
        `findSerializationTyping` in class `AnnotationIntrospector`
      Returns:
        Typing mode to use, if annotation is found; null otherwise

    - #### findSerializationViews

          public Class<?>[] findSerializationViews(Annotated a)

      Description copied from class: `AnnotationIntrospector`
      Method for checking if annotated serializable property (represented by field or getter method) has definitions for views it is to be included in. If null is returned, no view definitions exist and property is always included; otherwise it will only be included for views included in returned array. View matches are checked using class inheritance rules (sub-classes inherit inclusions of super-classes)
      Specified by:
        `findSerializationViews` in class `AnnotationIntrospector`
      Parameters:
        `a` - Annotated serializable property (field or getter method)
      Returns:
        Array of views (represented by classes) that the property is included in; if null, always included (same as returning array containing `Object.class`)

    - #### findSerializationPropertyOrder

          public String[] findSerializationPropertyOrder(AnnotatedClass ac)

      Description copied from class: `AnnotationIntrospector`
      Method for accessing defined property serialization order (which may be partial). May return null if no ordering is defined.
      Specified by:
        `findSerializationPropertyOrder` in class `AnnotationIntrospector`

    - #### findSerializationSortAlphabetically

          public Boolean findSerializationSortAlphabetically(AnnotatedClass ac)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether an annotation indicates that serialized properties for which no explicit is defined should be alphabetically (lexicograpically) ordered
      Specified by:
        `findSerializationSortAlphabetically` in class `AnnotationIntrospector`

    - #### findGettablePropertyName

          public String findGettablePropertyName(AnnotatedMethod am)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether given method has an annotation that suggests property name associated with method that may be a "getter". Should return null if no annotation is found; otherwise a non-null String. If non-null value is returned, it is used as the property name, except for empty String ("") which is taken to mean "use standard bean name detection if applicable; method name if not".
      Specified by:
        `findGettablePropertyName` in class `AnnotationIntrospector`

    - #### hasAsValueAnnotation

          public boolean hasAsValueAnnotation(AnnotatedMethod am)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether given method has an annotation that suggests that the return value of annotated method should be used as "the value" of the object instance; usually serialized as a primitive value such as String or number.
      Specified by:
        `hasAsValueAnnotation` in class `AnnotationIntrospector`
      Returns:
        True if such annotation is found (and is not disabled); false if no enabled annotation is found

    - #### findEnumValue

          public String findEnumValue(Enum<?> e)

      !!! 12-Oct-2009, tatu: This is hideously slow implementation, called potentially for every single enum value being serialized. Should improve...

      Overrides:
        `findEnumValue` in class `AnnotationIntrospector`
      Returns:
        Serialized enum value.

    - #### findSerializablePropertyName

          public String findSerializablePropertyName(AnnotatedField af)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether given member field represent a serializable logical property; and if so, returns the name of that property. Should return null if no annotation is found (indicating it is not a serializable field); otherwise a non-null String. If non-null value is returned, it is used as the property name, except for empty String ("") which is taken to mean "use the field name as is".
      Specified by:
        `findSerializablePropertyName` in class `AnnotationIntrospector`

    - #### findDeserializer

          public JsonDeserializer<?> findDeserializer(Annotated am)

      Description copied from class: `AnnotationIntrospector`
      Method for getting a deserializer definition on specified method or field. Type of definition is either instance (of type `JsonDeserializer`) or Class (of type `Class`); if value of different type is returned, a runtime exception may be thrown by caller.

      Note: this variant was briefly deprecated for 1.7; but it turns out we really should not try to push BeanProperty through at this point

      Specified by:
        `findDeserializer` in class `AnnotationIntrospector`

    - #### findKeyDeserializer

          public Class<KeyDeserializer> findKeyDeserializer(Annotated am)

      Description copied from class: `AnnotationIntrospector`
      Method for getting a deserializer definition for keys of associated `Map` property. Type of definition is either instance (of type `JsonDeserializer`) or Class (of type `Class`); if value of different type is returned, a runtime exception may be thrown by caller.
      Specified by:
        `findKeyDeserializer` in class `AnnotationIntrospector`

    - #### findContentDeserializer

          public Class<JsonDeserializer<?>> findContentDeserializer(Annotated am)

      Description copied from class: `AnnotationIntrospector`
      Method for getting a deserializer definition for content (values) of associated `Collection`, `array` or `Map` property. Type of definition is either instance (of type `JsonDeserializer`) or Class (of type `Class`); if value of different type is returned, a runtime exception may be thrown by caller.
      Specified by:
        `findContentDeserializer` in class `AnnotationIntrospector`

    - #### findDeserializationType

          public Class<?> findDeserializationType(Annotated a,
                                         JavaType baseType,
                                         String propName)

      JAXB does allow specifying (more) concrete class for deserialization by using \@XmlElement annotation.
      Specified by:
        `findDeserializationType` in class `AnnotationIntrospector`
        `baseType` - Assumed type before considering annotations
        `propName` - Logical property name of the property that uses type, if known; null for types not associated with property
      Returns:
        Class to use for deserialization instead of declared type

    - #### findDeserializationKeyType

          public Class<?> findDeserializationKeyType(Annotated am,
                                            JavaType baseKeyType,
                                            String propName)

      Description copied from class: `AnnotationIntrospector`
      Method for accessing additional narrowing type definition that a method can have, to define more specific key type to use. It should be only be used with `Map` types.
      Specified by:
        `findDeserializationKeyType` in class `AnnotationIntrospector`
        `baseKeyType` - Assumed key type before considering annotations
        `propName` - Logical property name of the property that uses type, if known; null for types not associated with property
      Returns:
        Class specifying more specific type to use instead of declared type, if annotation found; null if not

    - #### findDeserializationContentType

          public Class<?> findDeserializationContentType(Annotated a,
                                                JavaType baseContentType,
                                                String propName)

      Description copied from class: `AnnotationIntrospector`
      Method for accessing additional narrowing type definition that a method can have, to define more specific content type to use; content refers to Map values and Collection/array elements. It should be only be used with Map, Collection and array types.
      Specified by:
        `findDeserializationContentType` in class `AnnotationIntrospector`
        `baseContentType` - Assumed content (value) type before considering annotations
        `propName` - Logical property name of the property that uses type, if known; null for types not associated with property
      Returns:
        Class specifying more specific type to use instead of declared type, if annotation found; null if not

    - #### _doFindDeserializationType

          protected Class<?> _doFindDeserializationType(Annotated a,
                                            JavaType baseType,
                                            String propName)

    - #### findSettablePropertyName

          public String findSettablePropertyName(AnnotatedMethod am)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether given method has an annotation that suggests property name associated with method that may be a "setter". Should return null if no annotation is found; otherwise a non-null String. If non-null value is returned, it is used as the property name, except for empty String ("") which is taken to mean "use standard bean name detection if applicable; method name if not".
      Specified by:
        `findSettablePropertyName` in class `AnnotationIntrospector`

    - #### hasAnySetterAnnotation

          public boolean hasAnySetterAnnotation(AnnotatedMethod am)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether given method has an annotation that suggests that the method is to serve as "any setter"; method to be used for setting values of any properties for which no dedicated setter method is found.
      Overrides:
        `hasAnySetterAnnotation` in class `AnnotationIntrospector`
      Returns:
        True if such annotation is found (and is not disabled), false otherwise

    - #### hasCreatorAnnotation

          public boolean hasCreatorAnnotation(Annotated am)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether given annotated item (method, constructor) has an annotation that suggests that the method is a "creator" (aka factory) method to be used for construct new instances of deserialized values.
      Overrides:
        `hasCreatorAnnotation` in class `AnnotationIntrospector`
      Returns:
        True if such annotation is found (and is not disabled), false otherwise

    - #### findDeserializablePropertyName

          public String findDeserializablePropertyName(AnnotatedField af)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether given member field represent a deserializable logical property; and if so, returns the name of that property. Should return null if no annotation is found (indicating it is not a deserializable field); otherwise a non-null String. If non-null value is returned, it is used as the property name, except for empty String ("") which is taken to mean "use the field name as is".
      Specified by:
        `findDeserializablePropertyName` in class `AnnotationIntrospector`

    - #### findPropertyNameForParam

          public String findPropertyNameForParam(AnnotatedParameter param)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether given set of annotations indicates property name for associated parameter. No actual parameter object can be passed since JDK offers no representation; just annotations.
      Specified by:
        `findPropertyNameForParam` in class `AnnotationIntrospector`

    - #### findAnnotation

          protected <A extends Annotation> A findAnnotation(Class<A> annotationClass,
                                                Annotated annotated,
                                                boolean includePackage,
                                                boolean includeClass,
                                                boolean includeSuperclasses)

      Finds an annotation associated with given annotatable thing; or if not found, a default annotation it may have (from super class, package and so on)
      Parameters:
        `annotationClass` - the annotation class.
        `annotated` - The annotated element.
        `includePackage` - Whether the annotation can be found on the package of the annotated element.
        `includeClass` - Whether the annotation can be found on the class of the annotated element.
        `includeSuperclasses` - Whether the annotation can be found on any superclasses of the class of the annotated element.
      Returns:
        The annotation, or null if not found.